Subject: Re: bug#30187: M-e should restore isearch correctly in special modes

From: Juri Linkov <[email-masked]>
Date: Sun, 21 Jan 2018 23:23:03 +0200

>> All imaginable solutions were very bad.  But now I found a solution
>> that at least not bad.  It changes the global value of customizable
>> variables for the time while isearch is active (including the time
>> when isearch is suspended temporarily), and restores the original value
>> afterwards.
>
> What if the user QUITs out of the search -- will the original value be
> restored?

Yes, the original value is restored thanks to ‘condition-case’ with
‘quit’ in ‘with-isearch-suspended’ that guarantees that ‘isearch-abort’
is always called.